/* $Id: elm.h,v 1.23 2004/07/11 11:36:07 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.23 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *                           (was hurtta+elm@ozone.FMI.FI)
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/**  Main header file for ELM mail system.  **/


#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>

#include "defs.h"
#include <setjmp.h>
/*
#include "melib.h"
*/

#include "elmlib.h"

/******** static character string containing the version number  *******/

static char ident[] = { WHAT_STRING };

/******** and another string for the copyright notice            ********/

static char copyright[] = { 
		"@(#)          (C) Copyright 1986,1987, Dave Taylor\n\
@(#)          (C) Copyright 1988-1992, The Usenet Community Trust\n\
@(#)          (C) Copyright 1996-2004, Kari Hurtta\n" };

/******** global variables accessable by all pieces of the program *******/


int check_size = 0;		/* don't start mailer if no mail */


int inalias = 0;		/* TRUE if in the alias menu */
int last_current = -1;		/* previous current message */
int last_header_page = -1;     	/* last header page        */
int headers_per_page = 0;	/* number of headers/page  */
int original_umask = 0;		/* original umask, for restore before subshell */
int sendmail_verbose = 0;       /* Extended mail debugging */

int  nucurr = 0;	 		/* change list or just the current pointer...   */
char cur_editfile[SLEN] = {0};  /* editor buffer */

char batch_subject[SLEN] = {0};	/* subject buffer for batchmail */
char included_file[SLEN] = {0};	/* prepared file to include in the edit buf */

char version_buff[NLEN] = {0};	/* version buffer */
 
char *def_ans_yes;		/* default yes answer - single char, lc	*/
char *def_ans_no;		/* default no answer - single char, lc	*/
char *nls_deleted;		/* [deleted] */
char *nls_form;			/* Form */
char *nls_message;		/* Message */
char *nls_to;			/* To */
char *nls_from;			/* From */
char *nls_page;			/* Page */
char *change_word;		/* change */
char *save_word;		/* save */
char *copy_word;		/* copy */
char *cap_save_word;		/* Save */
char *cap_copy_word;		/* Copy */
char *saved_word;		/* saved */
char *copied_word;		/* copied */

int  has_highlighting = FALSE;	/* highlighting available? */


int write_elmrc = 0;            /* flag: write elmrc in starting    */






int mail_only = 0;		/* flag: send mail then leave?      */
int check_only = 0;		/* flag: check aliases then leave?  */
int batch_only = 0;		/* flag: send without prompting?    */

long size_of_pathfd;		/** size of pathfile, 0 if none **/

FILE *pathfd;			/* path alias file          */
FILE *domainfd;			/* domain file		    */

int system_data = -1;		/* fileno of system data file */
int user_data = -1;		/* fileno of user data file   */

JMP_BUF GetPromptBuf;		/* setjmp buffer */
int InGetPrompt;		/* set if in GetPrompt() in read() */

#ifdef USE_PGP

int pgp_status=0;    /* var to keep track of pgp internals */

#endif
int me_retcode;

short mime_count = 0; /* A counter used so that each call to
                       * mime_generate_boundary() returns a unique value.
                       */

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
