/* $Id: headers.h,v 1.26 2004/07/11 11:36:07 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.26 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *                           (was hurtta+elm@ozone.FMI.FI)
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/**  This is the header file for ELM mail system.  **/

#include "defs.h"
#include <setjmp.h>

#include "elmlib.h"

#include "mime.h"

/******** global variables accessable by all pieces of the program *******/


extern int check_size;		/* don't start mailer if no mail */


extern int inalias;		/* TRUE if in the alias menu */
extern int last_current;	/* previous current message */
extern int last_header_page;    /* last header page        */
extern int headers_per_page;	/* number of headers/page  */
extern int original_umask;	/* original umask, for restore before subshell */
extern int sendmail_verbose;    /* Allow extended debugging on sendmail */
extern int nucurr; 		/** change list or just the current pointer  **/

extern char cur_editfile[SLEN];   /* editor buffer */
extern char defaultfile[SLEN];	  /* name of default folder */

extern char batch_subject[SLEN];/* subject buffer for batchmail */
extern char included_file[SLEN];/* name of file to place in edit buf */

extern char version_buff[NLEN]; /* version buffer */

extern char *def_ans_yes;	/* default yes answer - single char, lc	*/
extern char *def_ans_no;	/* default no answer - single char, lc	*/
extern char *nls_deleted;	/* [deleted] */
extern char *nls_form;		/* Form */
extern char *nls_message;	/* Message */
extern char *nls_to;		/* To */
extern char *nls_from;		/* From */
extern char *nls_page;		/* Page */
extern char *change_word;	/* change */
extern char *save_word;		/* save */
extern char *copy_word;		/* copy */
extern char *cap_save_word;	/* Save */
extern char *cap_copy_word;	/* Copy */
extern char *saved_word;	/* saved */
extern char *copied_word;	/* copied */

extern int  has_highlighting;	/* highlighting available? */

extern int  write_elmrc;        /* flag: write elmrc in starting      */

extern int  mail_only;		/* flag: send mail then leave?        */
extern int  check_only;		/* flag: check aliases and leave?     */
extern int  batch_only;		/* flag: send without prompting?      */

extern long size_of_pathfd;	/** size of pathfile, 0 if none **/


extern FILE *pathfd;		/* path alias file          */
extern FILE *domainfd;		/* domains file 	    */

extern int system_data;		/* fileno of system data file */
extern int user_data;		/* fileno of user data file   */

#ifdef USE_PGP

extern int pgp_status;

extern int pgp_keeppassfor; /* how long to keep it before expiring */



#endif

extern int me_retcode;
extern char *mime_types[];

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
