static char rcsid[] = "@(#)$Id: shared_connect.c,v 1.3 2004/04/24 12:30:02 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI>
 *****************************************************************************/

/*
 * This file is compiled only if dlopen() is available, so
 * that file does not need to be guarded with #ifdef 
 */

#include "headers.h"

DEBUG_VAR(Debug,__FILE__,"dl");

#include "shared_imp.h"
#include "save_opts.h"
#include "cs_imp.h"
#include "mbx_imp.h"
#include "ss_imp.h"
#include "mailer_imp.h"

#if ANSI_C
#define S_(x) static x;
#else
#define S_(x)
#endif

#define SHARED_CONNECT_magic	0xF901


struct shared_ST * shared_stream_types           = NULL;
int   shared_stream_type_count                   = 0;

static struct shared_POP_CAPA {
    char                * capa;
    int                   priority;
    struct ImpInfo *      imp_idx;
    pop_capa_handler     *capa_handler;
} * shared_pop_capas                             = NULL;
static int shared_pop_capa_count                 = 0;

static struct shared_IMAP_CAPA {
    char                * capa;
    int                   priority;
    struct ImpInfo *      imp_idx;
    imap_capa_handler     *capa_handler;
} * shared_imap_capas                             = NULL;
static int shared_imap_capa_count                 = 0;


struct sl_connect_data {
  uint16            magic;      

};



S_(sl_reg_functions sl_reg_connect)
static int sl_reg_connect P_((struct ImpInfo *i,
			      int reg_idx));
static int sl_reg_connect(i,reg_idx)
     struct ImpInfo *i;
     int reg_idx;
{
    /* union hack to avoid warnings about casting
     * between pointer-to-object and pointer-to-function
     */

    int res = 0;

    union F1 {
	void *                 ptr;
	provides_shared_CT_f * f1;
    } f1;

    union F3 {
	void *                 ptr;
	provides_shared_ST_f * f3;
    } f3;
    
    union F4 {
	void *                       ptr;
	provides_shared_POP_CAPA_f * f4;
    } f4;

    union F5 {
	void *                       ptr;
	provides_shared_IMAP_CAPA_f * f5;
    } f5;

    union F6 {
	void *                       ptr;
	provides_shared_SEOT_f     * f6;
    } f6;


    union F14 {
	void *                       ptr;
	provides_shared_MCF_f      * f14;
    } f14;

    struct reg_list *r = & (i->regs[reg_idx]);

    if (&use_shared_connect != r->var)
	panic("SHARED PANIC",__FILE__,__LINE__,
	      "sl_reg_connect",
	      "Wrong variable",0);
    
    if (r->r.connect->magic != SHARED_CONNECT_magic)
	panic("SHARED PANIC",__FILE__,__LINE__,
	      "sl_reg_connect",
	      "Bad magic bumber",0);

    f1.ptr = dlsym(i->handle,  "provides_shared_CT");
    f3.ptr = dlsym(i->handle,  "provides_shared_ST");

    f4.ptr = dlsym(i->handle,  "provides_shared_POP_CAPA");
    f5.ptr = dlsym(i->handle,  "provides_shared_IMAP_CAPA");
    f6.ptr = dlsym(i->handle,  "provides_shared_SEOT");

    f14.ptr = dlsym(i->handle, "provides_shared_MCF");

    if (!f1.f1) {
	DPRINT(Debug,7,(&Debug," ... NO provides_shared_CT\n"));
    }

    if (!f3.f3) {
	DPRINT(Debug,7,(&Debug, " ... NO provides_shared_ST\n"));
    }

    if (!f4.f4) {
	DPRINT(Debug,7,(&Debug, " ... NO provides_shared_POP_CAPA\n"));
    }

    if (!f5.f5) {
	DPRINT(Debug,7,(&Debug, " ... NO provides_shared_IMAP_CAPA\n"));
    }

    if (!f6.f6) {
	DPRINT(Debug,7,(&Debug, " ... NO provides_shared_SEOT\n"));
    }

    if (!f14.f14) {
	DPRINT(Debug,7,(&Debug, " ... NO provides_shared_MCF\n"));
    }




#ifdef REMOTE_MBX
    if (f1.f1) {
	int count,x;
	size_t   s_res1;
	struct connection_type ** res1 = f1.f1(&count, &s_res1);
	
	if (s_res1 != sizeof (**res1)) {
	    DPRINT(Debug,1,(&Debug,
			    "... struct connection_type mismatch: %d should be %d\n",
			    s_res1,sizeof (**res1)));
	} else {
	    shared_connection_types = 
		safe_realloc(shared_connection_types,
			     sizeof (shared_connection_types[0]) *
			     (shared_connection_type_count + count));
	    
	    DPRINT(Debug,7,(&Debug," ... provides_shared_CT:  (shared_connection_types) count %d\n",
			    count));
	    
	    res = 1;

	    for (x = 0; x < count; x++) {
		shared_connection_types[shared_connection_type_count
					+x].T = res1[x];
		shared_connection_types[shared_connection_type_count
					+x].imp_idx = i;
	    }
	    shared_connection_type_count += count;
	}
    }
#endif

#ifdef REMOTE_MBX

	if (f3.f3) {
	    int count,x;
	    size_t   s_res3;
	    struct stream_type **res3 = f3.f3(&count, &s_res3);

	    if (s_res3 != sizeof (**res3)) {
		DPRINT(Debug,1,(&Debug,"... struct stream_type mismatch: %d should be %d\n",
				s_res3,sizeof (**res3)));
	    } else {
		shared_stream_types = 
		    safe_realloc(shared_stream_types,
				 sizeof (shared_stream_types[0]) *
				 (shared_stream_type_count + count));

		DPRINT(Debug,7,(&Debug," ... provides_shared_ST:  (shared_stream_types) count %d\n",
				count));
		
		res = 1;

		for (x = 0; x < count; x++) {
		    shared_stream_types[shared_stream_type_count
				       +x].T = res3[x];
		    shared_stream_types[shared_stream_type_count
					+x].imp_idx = i;
		}
		shared_stream_type_count += count;
	    }
	}

#endif


	if (f4.f4) {
	    int count,x;
	    size_t   s_res4;
	    struct provides_shared_POP_CAPA * res4 = f4.f4(&count, &s_res4);

	    if (s_res4 != sizeof (*res4)) {
		DPRINT(Debug,1,(&Debug,
				"... struct provides_shared_POP_CAPA mismatch: %d should be %d\n",
				s_res4,sizeof (*res4)));
	    } else {
		shared_pop_capas = 
		    safe_realloc(shared_pop_capas,
				 sizeof (shared_pop_capas[0]) *
				 (shared_pop_capa_count + count));
		
		DPRINT(Debug,7,(&Debug," ... provides_shared_IMAP_CAPA:  (shared_pop_capas) count %d\n",
				count));
		res = 1;
		
		for (x = 0; x < count; x++) {
		    shared_pop_capas[shared_pop_capa_count
				     +x].capa = res4[x].capa;
		    shared_pop_capas[shared_pop_capa_count
				     +x].priority = res4[x].priority;
		    shared_pop_capas[shared_pop_capa_count
				    +x].capa_handler = res4[x].capa_handler;
		    shared_pop_capas[shared_pop_capa_count
				     +x].imp_idx = i;
		    DPRINT(Debug,8,(&Debug,
				    "library %s provides POP %s\n", 
				    i->shname,
				    res4[x].capa));
		}
		shared_pop_capa_count += count;
	    }
	}

	if (f5.f5) {
	    int count,x;
	    size_t   s_res5;
	    struct provides_shared_IMAP_CAPA * res5 = f5.f5(&count, &s_res5);
	    
	    if (s_res5 != sizeof (*res5)) {
		DPRINT(Debug,1,(&Debug,
				"... struct provides_shared_IMAP_CAPA mismatch: %d should be %d\n",
				s_res5,sizeof (*res5)));
	    } else {
		shared_imap_capas = 
		    safe_realloc(shared_imap_capas,
				 sizeof (shared_imap_capas[0]) *
				 (shared_imap_capa_count + count));
		
		DPRINT(Debug,7,(&Debug," ... provides_shared_IMAP_CAPA:  (shared_imap_capas) count %d\n",
				count));
		res = 1;

		for (x = 0; x < count; x++) {
		    shared_imap_capas[shared_imap_capa_count
				     +x].capa = res5[x].capa;
		    shared_imap_capas[shared_imap_capa_count
				     +x].priority = res5[x].priority;
		    shared_imap_capas[shared_imap_capa_count
				     +x].capa_handler = 
			res5[x].capa_handler;
		    shared_imap_capas[shared_imap_capa_count
				     +x].imp_idx = i;
		    DPRINT(Debug,8,(&Debug,
				    "library %s provides IMAP %s\n", 
				    i->shname,
				    res5[x].capa));
		}
		shared_imap_capa_count += count;
	    }
	}	    


#ifdef REMOTE_MBX

	if (f6.f6) {
	    int count,x;
	    size_t   s_res6;
	    struct SE_option_type ** res6 = f6.f6(&count, &s_res6);

	    if (s_res6 != sizeof (**res6)) {
		DPRINT(Debug,1,(&Debug,"... struct SE_option_type mismatch: %d should be %d\n",
				s_res6,sizeof (**res6)));
	    } else {
		shared_SE_option_types = 
		    safe_realloc(shared_SE_option_types,
				 sizeof (shared_SE_option_types[0]) *
				 (shared_SE_option_type_count + count));

		DPRINT(Debug,7,(&Debug," ... provides_shared_SEOT:  (shared_SE_option_types) count %d\n",
				count));
		res = 1;
		
		for (x = 0; x < count; x++) {
		    shared_SE_option_types[shared_SE_option_type_count
					  +x].T = res6[x];
		    shared_SE_option_types[shared_SE_option_type_count
					  +x].imp_idx = i;
		}
		shared_SE_option_type_count += count;
	    }
	}
#endif
	


	if (f14.f14) {
	    int count;
	    size_t  s_res14, s_opt_size;

	    struct mailer_config *res14 = f14.f14(&count,&s_res14,
						  &s_opt_size);

	    if (s_res14 != sizeof (*res14)) {
		DPRINT(Debug,1,(&Debug,
				"...  struct mailer_config mismatch: %d should be %d\n",
				s_res14,sizeof (*res14)));
	    } else if (s_opt_size != sizeof (struct mailer_option_list)) {
		DPRINT(Debug,1,(&Debug,
				"...  struct mailer_option_list mismatch: %d should be %d\n",
				s_opt_size,sizeof (struct mailer_option_list)));
	    } else {		
		int x;

		shared_MCF_types = 
		    safe_realloc(shared_MCF_types,
				 sizeof (shared_MCF_types[0]) *
				 (shared_MCF_type_count + count));
		
		DPRINT(Debug,7,(&Debug," ... provides_shared_MCF:  (shared_MCF_types) count %d\n",
				count));
		res = 1;
		
		for (x = 0; x < count; x++) {
		    shared_MCF_types[shared_MCF_type_count+x].T = &(res14[x]);
		    shared_MCF_types[shared_MCF_type_count+x].imp_idx = i;
		}
		shared_MCF_type_count += count;
	    }
	}

	i->regs[reg_idx].valid   = res;

   return res;
}

S_(sl_zero_reg_list sl_zero_connect)
static void sl_zero_connect P_((struct dt_shared_info *var,
				struct reg_list *r));
static void sl_zero_connect(var,r)
     struct dt_shared_info *var;
     struct reg_list *r;
{
    r->var     = var;
    r->valid   = 0;
    r->r.connect  = safe_malloc(sizeof (*r->r.connect));   /* never freed ... */
    r->r.connect->magic = SHARED_CONNECT_magic;
}

S_(sl_unreg_functions sl_unreg_connect)
static void sl_unreg_connect P_((struct ImpInfo *i, int reg_idx));
static void sl_unreg_connect(i,reg_idx)
     struct ImpInfo *i; 
     int reg_idx;
{
    struct reg_list *r = & (i->regs[reg_idx] );
    r->valid   = 0;

}

static struct shared_loader connect_loader = {
    SHARED_LOADER_magic,
    sl_reg_connect,
    sl_zero_connect,
    sl_unreg_connect
};

SHAREDLIB use_shared_connect = {
    &connect_loader            /* loader */,
    0,                       
    NULL, 0
};

struct mailer_config  * loc_mailer_type(f)
     char *f;
{
    int x;
    
    /* We must load all connect libraries */
    load_shared_libs1(&use_shared_connect); 

 
   for (x = 0; x < shared_MCF_type_count; x++)
	if (0 == strcmp(shared_MCF_types[x].T->mailer_type,f)) {
	    return shared_MCF_types[x].T;
	}
    return NULL;
}

/* ------------------------------------------------------------------------ */


#ifdef REMOTE_MBX



static enum CAPA_phase pri_to_phase P_((int pri));
static enum CAPA_phase pri_to_phase(pri)
     int pri;
{
    
    if (pri < 10)
	return capa_prelogin;
    if (pri < 20)
	return capa_do_login;
    return capa_logged;
}


struct POP_capa_libs {
    char                 * capa;
    char                 * capa_args;
    struct ImpInfo       * imp_idx;
    int                    priority;
    pop_capa_handler     * capa_handler;
};

void probe_pop_capa_lib(pop_capa_libs,pop_capa_libcount,capa,capa_args)
     struct POP_capa_libs * *pop_capa_libs;
     int                  * pop_capa_libcount;
     CONST char *capa;
     CONST char *capa_args;
{
    int i;

    load_shared_libs1(&use_shared_connect);  

    for (i = 0; i < shared_pop_capa_count; i++) {
	/* rfc2449: CAPA response tags are case-insensitive. */


	/* Also check that librrary is currently loaded ... */
	if (!verify_shared_index(shared_pop_capas[i].imp_idx)) {
	    DPRINT(Debug,8,(&Debug,"shared_pop_capas[%d] unloaded?\n",i));
	    continue;
	}

	if ( 0 == istrcmp(shared_pop_capas[i].capa, capa))
	    break;	
    }
    if (i >= shared_pop_capa_count)
	return;          /* Not found */

    DPRINT(Debug,8,(&Debug,"shared_pop_capas[%d] is %s\n",i,capa));

    *pop_capa_libs = safe_realloc(*pop_capa_libs,
				  (*pop_capa_libcount +1) *
				  sizeof ((*pop_capa_libs)[0]));

    (*pop_capa_libs)[*pop_capa_libcount].capa      = safe_strdup(capa);
    
    (*pop_capa_libs)[*pop_capa_libcount].capa_args = 
	capa_args ? safe_strdup(capa_args) : NULL;
    (*pop_capa_libs)[*pop_capa_libcount].imp_idx   = 
	shared_pop_capas[i].imp_idx;
    (*pop_capa_libs)[*pop_capa_libcount].priority  = 
	shared_pop_capas[i].priority;
    (*pop_capa_libs)[*pop_capa_libcount].capa_handler =
	shared_pop_capas[i].capa_handler;

    DPRINT(Debug,7,(&Debug,
		    "** Using %s library for POP capacity %s\n",
		    shared_pop_capas[*pop_capa_libcount].
				    imp_idx->tag,
		    (*pop_capa_libs)[*pop_capa_libcount].capa));

    (*pop_capa_libcount)++;		
}

static int pop_capa_compare P_((const void *A, const void *B));
static int pop_capa_compare(A,B)
     CONST void *A; 
     CONST void *B;
{
    CONST struct POP_capa_libs *A1 = A;
    CONST struct POP_capa_libs *B1 = B;

    if (A1->priority < B1->priority)
	return -1;
    if (A1->priority > B1->priority)
	return 1;
    return 0;
}


int handle_pop_capa_libs(folder,pop_capa_libs,pop_capa_libcount,phase,commands)
     struct folder_info *folder;
     struct POP_capa_libs * *pop_capa_libs;
     int                  * pop_capa_libcount;
     enum CAPA_phase      *  phase;
     struct pop_callbacks *commands;
{
    int ret = 1;
    struct remote_account * A;
    enum CAPA_phase  old_phase = *phase;

    if (!folder->p ||
	folder->folder_type != &pop_mbx) 
	panic("CONNECTION PANIC",__FILE__,__LINE__,"handle_pop_capa_libs",
	      "Not a POP connection",0);
        
    A = &(folder->p->a.pop_mbx.C);
    
    if (*pop_capa_libs) {
	int i;
	qsort(*pop_capa_libs,*pop_capa_libcount,
	      sizeof ((*pop_capa_libs)[0]),
	      pop_capa_compare);

	
	for (i = 0; i < *pop_capa_libcount; i++) {
	    struct SE_option       *config = NULL;
	    struct SE_option_type  *T      = NULL;
	    int j;

	    if (*phase != pri_to_phase((*pop_capa_libs)[i].priority))
		continue;

	    DPRINT(Debug,8,(&Debug,
			    "[%d] handling %s with %s library\n",
			    i,(*pop_capa_libs)[i].capa,
			    shared_pop_capas[i].imp_idx->tag));

	    for (j = 0; j < shared_SE_option_type_count; j++) {
		if (shared_SE_option_types[j].imp_idx ==
		    shared_pop_capas[j].imp_idx) {
		    T = shared_SE_option_types[j].T;
		    DPRINT(Debug,8,(&Debug,
				    "  ... have service option type %p\n",
				    T));
		}
	    }

	    if (A->service_idx >= 0 && T) {
		if (A->service_idx >= service_count) 
		    panic("CONNECTION PANIC",__FILE__,__LINE__,
			  "handle_pop_capa_libs",
			  "Bad service index",0);
		
		for (j = 0; 
		     j < service_list[A->service_idx].option_count; 
		     j++) {
		    if (service_list[A->service_idx].
			option_list[j].type == T) {
			config = & (service_list[A->service_idx].
				    option_list[j]);
			DPRINT(Debug,8,(&Debug,
					"  ... have service config %p (%s)\n",
					config,
					config->prefix ? config->prefix : "NONE"));
		    }
		}		
	    }


	    if (!(*pop_capa_libs)[i].
		capa_handler(folder,
			     (*pop_capa_libs)[i].capa,
			     (*pop_capa_libs)[i].capa_args,
			     sizeof (*folder),
			     commands,
			     sizeof (*commands),
			     config,
			     sizeof (*config),
			     phase)) {
		ret = 0;
		goto fail;
	    }

	    if (*phase != old_phase) {
		DPRINT(Debug,8,(&Debug," ... done (phase changed)\n"));
		break;
	    }
	}

    fail:
	free(*pop_capa_libs);
	*pop_capa_libs     = NULL;
	*pop_capa_libcount = 0;
    }
    return ret;
}

struct IMAP_capa_libs {
    char                 *  capa;
    struct ImpInfo       *  imp_idx;
    int                     priority;
    imap_capa_handler     * capa_handler;
};

void probe_imap_capa_lib(imap_capa_libs,imap_capa_libcount,capa)
     struct IMAP_capa_libs * *imap_capa_libs;
     int                  * imap_capa_libcount;
     CONST char *capa;
{
    int i;

    load_shared_libs1(&use_shared_connect);  
    
    for (i = 0; i < shared_imap_capa_count; i++) {
	/* rfc2460:  (Syntax) Except as noted otherwise, 
	   all alphabetic characters are case-insensitive.
	*/
	
	/* Also check that library is currently loaded ... */
	if (!verify_shared_index(shared_imap_capas[i].imp_idx)) {
	    DPRINT(Debug,8,(&Debug,"shared_imap_capas[%d] unloaded?\n",i));
	    continue;
	}

	if ( 0 == istrcmp(shared_imap_capas[i].capa, capa))
	    break;	
    }
    if (i >= shared_imap_capa_count)
	return;          /* Not found */
    
    DPRINT(Debug,8,(&Debug,"shared_imap_capas[%d] unloaded is %s\n",i,capa));

    *imap_capa_libs = safe_realloc(*imap_capa_libs,
				   (*imap_capa_libcount +1) *
				   sizeof ((*imap_capa_libs)[0]));

    (*imap_capa_libs)[*imap_capa_libcount].capa      = safe_strdup(capa);
    
    (*imap_capa_libs)[*imap_capa_libcount].imp_idx   = 
	shared_imap_capas[i].imp_idx;
    (*imap_capa_libs)[*imap_capa_libcount].priority  = 
	shared_imap_capas[i].priority;
    (*imap_capa_libs)[*imap_capa_libcount].capa_handler =
	shared_imap_capas[i].capa_handler;

    DPRINT(Debug,7,(&Debug,
		    "** Using %s library for IMAP capacity %s\n",
		    shared_imap_capas[*imap_capa_libcount].imp_idx->tag,
		    (*imap_capa_libs)[*imap_capa_libcount].capa));

    (*imap_capa_libcount)++;		

}

static int imap_capa_compare P_((const void *A, const void *B));
static int imap_capa_compare(A,B)
     CONST void *A; 
     CONST void *B;
{
    CONST struct IMAP_capa_libs *A1 = A;
    CONST struct IMAP_capa_libs *B1 = B;

    if (A1->priority < B1->priority)
	return -1;
    if (A1->priority > B1->priority)
	return 1;
    return 0;
}
				
int handle_imap_capa_libs(con,imap_capa_libs,imap_capa_libcount,phase,commands)
     struct connection_cache *con;
     struct IMAP_capa_libs * *imap_capa_libs;
     int                    * imap_capa_libcount;
     enum CAPA_phase        * phase;
     struct imap_callbacks *commands;
{
    int ret = 1;

    struct remote_account * A;
    enum CAPA_phase old_phase = *phase;

    if (con->type != &IMAP_connection) 
	panic("CONNECTION PANIC",__FILE__,__LINE__,"handle_imap_capa_libs",
	      "Not a imap connection",0);
        
    A = &(con->C);


    if (*imap_capa_libs) {
	int i;
	qsort(*imap_capa_libs,*imap_capa_libcount,
	      sizeof ((*imap_capa_libs)[0]),
	      imap_capa_compare);
	
	for (i = 0; i < *imap_capa_libcount; i++) {
	    struct SE_option       *config = NULL;
	    struct SE_option_type  *T      = NULL;
	    int j;
	    
	    if (*phase != pri_to_phase((*imap_capa_libs)[i].priority))
		continue;
	    
	    DPRINT(Debug,8,(&Debug,
			    "[%d] handling %s with %s library\n",
			    i,(*imap_capa_libs)[i].capa,
			    shared_imap_capas[i].imp_idx->tag));

	    for (j = 0; j < shared_SE_option_type_count; j++) {
		if (shared_SE_option_types[j].imp_idx ==
		    shared_pop_capas[j].imp_idx) {
		    T = shared_SE_option_types[j].T;
		    DPRINT(Debug,8,(&Debug,
				    "  ... have service option type %p\n",
				    T));
		}
	    }
	    
	    if (A->service_idx >= 0 && T) {
		if (A->service_idx >= service_count) 
		    panic("CONNECTION PANIC",__FILE__,__LINE__,
			  "handle_pop_capa_libs",
			  "Bad service index",0);
		
		for (j = 0; 
		     j < service_list[A->service_idx].option_count; 
		     j++) {
		    if (service_list[A->service_idx].
			option_list[j].type == T) {
			config = & (service_list[A->service_idx].
				    option_list[j]);
			DPRINT(Debug,8,(&Debug,
					"  ... have service config %p (%s)\n",
					config,
					config->prefix ? config->prefix : 
					"NONE"));
		    }
		}		
	    }

	    if (!(*imap_capa_libs)[i].
		capa_handler(con,
			     (*imap_capa_libs)[i].capa,
			     sizeof (*con),
			     commands,
			     sizeof (*commands),
			     config,
			     sizeof (*config),
			     phase)) {
		ret = 0;
		goto fail;
	    }
	    
	    if (old_phase != *phase) {
		DPRINT(Debug,8,(&Debug," ... done (phase changed)\n"));
		break;
	    }
	}

    fail:
	;
    }

    free_only_imap_capa_libs(imap_capa_libs,imap_capa_libcount);

    return ret;

}


void free_only_imap_capa_libs(imap_capa_libs,imap_capa_libcount)
     struct IMAP_capa_libs * *imap_capa_libs;
     int                  * imap_capa_libcount;
{
    if (*imap_capa_libs) {
	int i;

	for (i = 0; i < *imap_capa_libcount; i++) {
	    if ((*imap_capa_libs)[i].capa) {
		free((*imap_capa_libs)[i].capa);
		(*imap_capa_libs)[i].capa = NULL;
	    }
	}
	free(*imap_capa_libs);
	*imap_capa_libs     = NULL;
	*imap_capa_libcount = 0;
    }
}

#endif


/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 * End:
 */
