static char rcsid[] = "@(#)$Id: canceled.c,v 1.5 2004/07/28 18:00:56 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.5 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 ****************************************************************************
 * Some code copiend from src/elm.c and src/leavembox.c. 
 * On these are following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

static void cancel_menu P_((struct menu_context *page));
static void cancel_menu(page)
     struct menu_context *page;
{
    /** write main system menu... **/
    int LINES, COLUMNS;

    menu_get_sizes(default_context,&LINES, &COLUMNS);
    
    print_format_center(LINES-8, 
			CATGETS(elm_msg_cat, ElmSet, 
				ElmCancelMenuLine1,
				"To select canceled message for mailing, press <return>."));
    print_format_center(LINES-7, 
			CATGETS(elm_msg_cat, ElmSet, 
				ElmCancelMenuLine2,
				"To read message, press space.   j = move down, k = move up"));
    print_format_center(LINES-6, 
			CATGETS(elm_msg_cat, ElmSet, 
				ElmCancelMenuLine3,
				"Also available: d)elete, u)ndelete, i)ndex"));

}


static int showmsg_cancel_cmd P_((     struct MailboxView *mailbox,
				       int cmd, int *screen_mangled,
					struct menu_context *page));
static int showmsg_cancel_cmd(mailbox,cmd,screen_mangled, page)
     struct MailboxView *mailbox;
     int cmd; 
     int *screen_mangled;
     struct menu_context *page;
{


    return cmd;
}

/* This leaks on exit */
char * last_canceled_mail = NULL;

int view_canceled_mails(cancel_view,cancel_selection,aview)
     struct MailboxView * cancel_view;
     int *cancel_selection;
     struct AliasView *aview;
{

    int leave = 0;
    int redraw = 0, nufoot = 0;
    int can_flag = 0;
    int i;

    struct menu_context  *page = new_menu_context();

    struct menu_common MENU;
    int   LINES, COLUMNS;	
    
    int header_page = 0;
    if (get_message_count(cancel_view) > 0) {

	if (! last_canceled_mail ||
	    ! cancel_set_current(cancel_view,last_canceled_mail))
	    set_current(cancel_view,1);   /* Set current to first message */

	update_view(cancel_view);
	resort_mailbox(cancel_view,1, &header_page);
    }

 start_again:
    leave = 0;

    menu_get_sizes(page,&LINES, &COLUMNS);

    set_mcommon_from_mbxview(&MENU,cancel_view);

    showscreen(cancel_view,
	       cancel_menu,&header_page, page);
    
    while (!leave) {
	int ch;

	if (menu_resized(page)) {
	    
	    menu_get_sizes(page,&LINES, &COLUMNS);

#undef max
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (LINES - 14, 1);
		else
		    headers_per_page = max (LINES -  9, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	} else 
	    redraw = menu_need_redraw(page);
	
	nufoot = 0;
	nucurr = 0;

	new_mail_check(cancel_view, &header_page, page);
	redraw += menu_need_redraw(page);

	if (update_view(cancel_view)) {
	    resort_mailbox(cancel_view,1, &header_page);

	    redraw++;
	}

	if (redraw) {
	    redraw = 0;
	    showscreen(cancel_view,
		       cancel_menu,&header_page, page);
	    show_last_error();
	}
	

	  {
	      int lin,col;
	      prompt_s(mcommon_give_item(&MENU,m_Prompt));
	      GetXYLocation(&lin,&col);

	      CleartoEOLN();
	      ch = GetPrompt(page);
	
	      CleartoEOS();
	      
	      if (isascii(ch) && isprint(ch)) {
		  DPRINT(Debug,4,(&Debug, 
				  "\nCommand: %c [%d]\n\n", ch, ch));
	      } else {
		  DPRINT(Debug,4,(&Debug, 
				  "\nCommand: %d\n\n", ch));
	      }
	      
	      set_error("");	/* clear error buffer */
	      
	      MoveCursor(lin,col);
	  }

	ch = motion(ch,&MENU,&nufoot, &header_page,
			page);
	redraw += menu_need_redraw(page);

	switch (ch) {
	case 0:  /* OK */
	    break;

	quit_mark:
	case ctrl('Q') :

	case 'Q':
	case 'X':

	    leave = -2;
	    break;
	case 'q':
	case 'i':

	    leave = 1;

	    break;

	case '$':
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet, 
				    ElmResyncFolder,
				    "Resynchronize folder"));
	    FlushBuffer();
	    leave = -1;
	    break;
	    
        case ' ':  /*   Copied from mailbox_command */ {
	    int current = get_current(cancel_view);
		
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				ElmDisplayMessage,
				    "Display message"));  
	    FlushBuffer();
	    
	    if (current < 1)
		lib_error(CATGETS(elm_msg_cat, ElmSet, 
				  ElmNoMailToRead,
				  "No mail to read!"));
	    else {
		struct header_rec *hdr;
		FILE *F;
		int i = 0;	    
		
		/* define_softkeys(READ); */
		
		
		if (give_message_data(cancel_view,current-1,
				      &hdr,&F,NULL,
				      mime_parse_routine))
		    i = show_msg(hdr,F,current,
				 get_message_count(cancel_view),
				 page);
		else {
		    DPRINT(Debug,3,(&Debug, 
				    "give_message_data [%d] fails",current-1));
		}
		
		while (i > 0) {
		    i = process_showmsg_cmd(i, cancel_view, 
					    showmsg_cancel_cmd, 
					    aview, &header_page,
					    page);
		    
		    switch (i) {
		    case EOF:
			goto eof_mark;
			
		    case 'X':      /* Quick Exit */
			
			goto quit_mark;
		    case 0:
			break;
			
		    default:
			DPRINT(Debug,3,(&Debug, 
					"Looping showmsg command %d (%c)\n",
					i,i));		    
		    }
		}
		
		current = get_current(cancel_view);
		
		redraw++;
		(void)get_page(current, &MENU, &header_page);
	    }
	}
	    break;

    case ctrl('J'):
    case ctrl('M'): {
	int current = get_current(cancel_view);
		
	Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				ElmSelectCanMessage,
				"Select Canceled message"));  

	FlushBuffer();
	if (current > 0) {
	    *cancel_selection = current -1;
	    leave    = 1;
	    can_flag = 1;
	}
    }
	break;

	eof_mark:
	case EOF:
	    
	    goto OUT;

	default:
	    lib_error(CATGETS(elm_msg_cat, ElmSet,
			      ElmUnknownCommand2,			
			      "Unknown command."));

	}
	
	if (redraw)
	    showscreen(cancel_view,
		       cancel_menu,&header_page, page);
	
	check_range(&MENU);
	
	
	if (nucurr == NEW_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == NEW_PAGE\n"));
	    show_headers(&MENU,&header_page, page);
	} else if (nucurr == SAME_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == SAME_PAGE\n"));
	    show_current(&MENU,&header_page, page);
	} else if (nufoot) {
	    if (mini_menu) {
		MoveCursor(LINES-8, 0);  
		CleartoEOS();
		cancel_menu(page);
	    }
	    else {
		MoveCursor(LINES-5, 0);
		CleartoEOS();
	    }
	    show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
	}

    } /* the BIG while loop! */


    if (leave != -2) {
	int marked_deleted = 0;

	for (i = 0; i < get_message_count(cancel_view); i++) {
	    if (mcommon_ison_status(&MENU,i,DELETED))
		marked_deleted++;
	}
	
	if (marked_deleted > 0) {
	    int answer = (always_del ? 
			  *def_ans_yes : *def_ans_no);	/* default answer */
	    
	    if(question_me) {
		int def = answer;
		
		/* NOTICE: prompt_letter may return EOF */
		if (marked_deleted == 1)
		    answer = prompt_letter(LINES-4,"",def,
					   PROMPT_yesno|PROMPT_cancel|
					   PROMPT_redraw_mark|PROMPT_ctrlL,
					   page,
					   CATGETS(elm_msg_cat, ElmSet, 
						   ElmLeaveDeleteMessage,
						   "Delete message? (%c/%c) "), 
					   *def_ans_yes, *def_ans_no);
		else
		    answer = prompt_letter(LINES-4,"",def,
					   PROMPT_yesno|PROMPT_cancel|
					   PROMPT_redraw_mark|PROMPT_ctrlL,	
					   page,				       
					   CATGETS(elm_msg_cat, ElmSet, 
						   ElmLeaveDeleteMessages,
						   "Delete messages? (%c/%c) "), 
					   *def_ans_yes, *def_ans_no);
		
		if (TERMCH_interrupt_char == answer) {
		    leave = 0;
		    can_flag = 0;
		    goto start_again;	    
		}
		
		if (answer == ('L'&31) || answer == REDRAW_MARK) {
		    menu_ClearScreen(page);      
		    goto start_again;
		}

		if (answer == EOF) {
		    can_flag = 0;
		    goto OUT;
		}
	    }
	    
	    if (answer == *def_ans_yes) {
		/* NOTICE: This does not update index so
		 *cancel_selection is still valid */
		
		delete_marked_canceled_mails(cancel_view);
	    }
	    
	}
    }

    if (leave == -1) {
	int n;

	*cancel_selection = -1;
	can_flag = 0;

	sync_canceled_mails(cancel_view) ;
	
	if (get_current(cancel_view) > (n = get_message_count(cancel_view)))
	    set_current(cancel_view,n);

	resort_mailbox(cancel_view,1, &header_page);
	
	goto start_again;
    }

 OUT:
    erase_menu_context(&page);

    DPRINT(Debug,4,(&Debug, "view_canceled_mails=%d *cancel_selection=%d\n",
		    can_flag,*cancel_selection));
    return can_flag;
}



/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
