static char rcsid[] = "@(#)$Id: delete.c,v 1.18 2004/03/27 18:31:44 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.18 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *
 *****************************************************************************/

/**  Delete or undelete files: just set flag in header record! 
     Also tags specified message(s)...

**/

#include "def_elm.h"
#include "s_elm.h"

void delete_msg(real_del, update_screen, menu, header_page)
     int real_del, update_screen;
     struct menu_common *menu;
     int header_page;
{
    /** Delete current message.  If real-del is false, then we're
	actually requested to toggle the state of the current
	message... 
    **/
    int current = mcommon_get_current(menu);
    
    if (mcommon_get_type(menu, current-1) & SYSTEM)
	lib_error(CATGETS(elm_msg_cat, ElmSet, ElmNoDelSysAlias,
			  "Can't delete a system alias!"));
    else if (real_del) {
	
	mcommon_setf_status(menu,current-1,DELETED);

    } else {

	if (mcommon_ison_status(menu,current-1,DELETED))
	    mcommon_clearf_status(menu,current-1,DELETED);
	else
	    mcommon_setf_status(menu,current-1,DELETED);
		
    }

    if (update_screen)
	show_msg_status(current-1,menu, header_page);
}

void unread_msg(update_screen, mailbox, header_page)
     int update_screen;
     struct MailboxView *mailbox;
     int header_page;
{
    int current = get_current(mailbox);
    struct header_rec * hdr = give_header(mailbox,current-1);

  	/** change the message flag to unread **/
   
    if (hdr) {
 	setit(hdr->status, UNREAD);
	hdr->status_chgd = TRUE;
    }

    if (update_screen) {	    
	struct menu_common MENU;

	set_mcommon_from_mbxview(&MENU, mailbox);

	show_msg_status(current-1, &MENU, header_page);
    }
}

void undelete_msg(update_screen,menu,header_page)
     int update_screen;
     struct menu_common *menu;
     int header_page;
{
    int current = mcommon_get_current(menu);

    mcommon_clearf_status(menu,current-1,DELETED);

    if (update_screen)
	show_msg_status(current-1,menu, header_page);
}

void show_msg_status(msg, menu, header_page)
     int msg;
     struct menu_common *menu;
     int header_page;
{
    /** show the status of the current message only.  **/

    char tempbuf[3];
    int current = 0;

    /* ??? */
    strfcpy(tempbuf, mcommon_show_status(menu,msg), sizeof tempbuf);

    if (on_page(msg, menu, header_page)) {
	MoveCursor(((compute_visible(msg+1, menu)-1) 
		    % headers_per_page) + 4, 2);
	if (msg+1 == current && !arrow_cursor) {
	    StartBold();
	    Writechar( tempbuf[0] );
	    EndBold();
	}
	else
	    Writechar( tempbuf[0] );
    }
}

int tag_message(update_screen, menu, header_page)
     int update_screen;
     struct menu_common *menu;
     int header_page;
{
    /** Tag current message and return TRUE.
	If already tagged, untag it and return FALSE. **/
    
	int istagged;
	int current = mcommon_get_current(menu);

	if (mcommon_ison_status(menu,current-1,TAGGED)) {

	    mcommon_clearf_status(menu,current-1,TAGGED);
	    istagged = FALSE;

	} else {

	    mcommon_setf_status(menu,current-1,TAGGED);
	    istagged = TRUE;

	}

	if(update_screen)
	    show_msg_tag(current-1,menu, header_page);

	return(istagged);
}

void show_msg_tag(msg, menu, header_page)
     int msg;
     struct menu_common *menu;
     int header_page;
{
    /** show the tag status of the current message only.  **/

    int current = mcommon_get_current(menu);

    if (on_page(msg, menu, header_page)) {

	MoveCursor(((compute_visible(msg+1, menu)-1) % 
		    headers_per_page) + 4, 4);

	if (msg+1 == current && !arrow_cursor) {

	    StartBold();
	    Writechar(mcommon_ison_status(menu,msg,TAGGED)? '+' : ' ');
	    EndBold();

	} else {

	    Writechar(mcommon_ison_status(menu,msg,TAGGED)? '+' : ' ');

	}
    }
}

void show_new_status(msg,menu, header_page)
     int msg;
     struct menu_common *menu;
     int header_page;
{
    /** If the specified message is on this screen, show
	the new status (could be marked for deletion now,
	and could have tag removed...)
    **/

    if (on_page(msg, menu, header_page)) {
	char * s = "";
	char   c = ' ';
	int current =  0;
    
	current = mcommon_get_current(menu);
	s = mcommon_show_status(menu,msg);
	c = mcommon_ison_status(menu,msg,TAGGED) ? '+' : ' ';
	
	if (msg+1 == current && !arrow_cursor) {
	    StartBold();
	    
	    PutLineX(((compute_visible(msg+1,menu)-1) 
		      % headers_per_page) + 4,
		     2, FRM("%s%c"), 
		     s,c);

	    EndBold();
	  } else
	      PutLineX(((compute_visible(msg+1,menu)-1) 
			% headers_per_page) + 4,
		       2, FRM("%s%c"), 
		       s,c);
	
    }
}

int DeleteTagged(menu, header_page,page)
     struct menu_common *menu;
     int header_page;
     struct menu_context  *page;
{

    /** delete all tagged messages.  return TRUE if the current message was
	deleted. 
    **/

    int iindex, count = 0;  
    int mc      = mcommon_get_count(menu);
    int current = mcommon_get_current(menu);
    int LINES, COLUMNS;

    menu_get_sizes(page, &LINES, &COLUMNS);

    for (iindex=0; iindex < mc; iindex++) {
	if (mcommon_ison_status(menu,iindex,TAGGED)) {

	    mcommon_setf_status(menu,iindex,DELETED);
	    count++;
	    show_new_status(iindex,menu, header_page);
	}
    }
    
    if (count == 1)
	print_format_center(LINES-1,
			    CATGETS(elm_msg_cat, ElmSet, ElmItemDeleted,
				    "%S deleted."),
			    mcommon_give_item(menu,m_Item));
    else
	print_format_center(LINES-1,
			    CATGETS(elm_msg_cat, ElmSet, ElmItemsDeleted,
				    "%d %S deleted."), 
			    count,
			    mcommon_give_item(menu,m_items));
    
    return( mcommon_ison_status(menu,current-1, DELETED) ? 1 : 0);        
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
