static char rcsid[] = "@(#)$Id: digest.c,v 1.11 2004/07/26 12:41:46 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.11 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
 ******************************************************************************
 * This routine mimics some routines from src/file.c and src/elm.c.
 * That code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

static void digest_menu P_((struct menu_context  *page));
static void digest_menu(page)
     struct menu_context  *page;
{
    /** write main system menu... **/
    int LINES, COLUMNS;
	
    menu_get_sizes(page, &LINES, &COLUMNS);
    
    if (user_level == 0) {	/* a rank beginner.  Give less options  */
	print_format_center(LINES-8, 
			      CATGETS(elm_msg_cat, ElmSet, 
				      ElmLevel0MenuLine1,
				      "You can use any of the following commands by pressing the first character;"));
         print_format_center(LINES-7, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0DgtLine2,
				     "m)ail a message,  r)eply or f)orward mail,  return to i)ndex"));
	 print_format_center(LINES-6, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0DgtLine3,
				     "To read a message, press <return>.  j = move down, k = move up"));
    } else {
	print_format_center(LINES-8, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1MenuLine1,
				    "|=pipe, !=shell, ?=help, <n>=set current to n, /=search pattern"));
        print_format_center(LINES-7, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1DgtLine2,
				    "a)lias, C)opy, f)orward, g)roup reply, m)ail,"));
	print_format_center(LINES-6, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1DgtLine3,
				    "n)ext, o)ptions, P)rint text, r)eply, s)ave, t)ag, or i)index"));
    }
}

static int showmsg_digest_cmd P_((     struct MailboxView *mailbox,
				       int cmd, int *screen_mangled,
				           struct menu_context  *page));
static int showmsg_digest_cmd(mailbox,cmd,screen_mangled,page)
     struct MailboxView *mailbox;
     int cmd; 
     int *screen_mangled;
     struct menu_context  *page;
{
    return cmd;
}


static void digest_loop P_((struct MailboxView *mailbox,
			    struct AliasView *aview,
			    int header_page));
static void digest_loop(mailbox, aview, header_page)
     struct MailboxView *mailbox;
     struct AliasView *aview;
     int header_page;
{
    int leave = 0;
    int redraw = 0, nufoot = 0;
    int auto_assemble = 1;

    struct menu_context  *page = new_menu_context();

    showscreen(mailbox,
	       digest_menu,&header_page, page);


    while (!leave) {
	int ch;
	struct menu_common MENU;
	int   LINES, COLUMNS;	

	menu_get_sizes(page,&LINES, &COLUMNS);

	set_mcommon_from_mbxview(&MENU,mailbox);

	if (menu_resized(page)) {
	    
	    menu_get_sizes(page,&LINES, &COLUMNS);

#undef max
#define max(a,b)	       ((a) < (b) ? (b) : (a))
	    if (mini_menu)
		headers_per_page = max (LINES - 14, 1);
	    else
		headers_per_page = max (LINES -	 9, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	} else 
	    redraw = menu_need_redraw(page);

	nufoot = 0;
	nucurr = 0;


	if (update_view(mailbox)) {
	    resort_mailbox(mailbox,1, &header_page);

	    redraw++;
	}

	if (redraw) {
	    redraw = 0;
	    showscreen(mailbox,
		       digest_menu,&header_page, page);
	    show_last_error();
	}
	
	
	{
	    int lin,col;

	    prompt_s(mcommon_give_item(&MENU, m_Prompt));
	    GetXYLocation(&lin,&col);

	    CleartoEOLN();

	    if (auto_assemble && 2 == fragment_handling &&
		have_partial(mailbox)) {
		ch = 'A';
		auto_assemble = 0;
		
		DPRINT(Debug,4,(&Debug,"Automatic assemble ... \n"));
	    } else
		ch = GetPrompt(page);
	
	    CleartoEOS();

	    if (isascii(ch) && isprint(ch)) {
		DPRINT(Debug,4,(&Debug, 
				"\nCommand: %c [%d]\n\n", ch, ch));
	    } else {
		DPRINT(Debug,4,(&Debug, 
				"\nCommand: %d\n\n", ch));
	    }
	    
	    set_error("");	/* clear error buffer */
	
	    MoveCursor(lin,col);
	}	

	ch = mailbox_command(mailbox,ch, &nufoot,
			     showmsg_digest_cmd, aview,
			     &header_page,page);

	redraw += menu_need_redraw(page);

	switch (ch) {
	case 0:  /* OK */
	    break;

	case 'A': {
	    int current = get_current(mailbox);


	    Write_to_screen(CATGETS(elm_msg_cat, 
					     ElmSet, ElmAssemble,
					     "Assemble message fragments"));
	    FlushBuffer();
	    sleep_message();

	    ViewPartial(mailbox,aview);
	    
	    (void)get_page(current, &MENU, &header_page);
	    redraw++;

	}
	    break;

	case ctrl('Q') :
	case 'q':
	case 'Q':
	case 'i':
	case 'x':
	case 'X':
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				    ElmReturnIndex,
				    "Return to index"));  
	    FlushBuffer();

	    leave = 1;

	    break;
	case EOF:
	    
	    goto OUT;

	default:
	    lib_error(CATGETS(elm_msg_cat, ElmSet,
			      ElmUnknownCommand2,			
			      "Unknown command."));

	}
	
	if (redraw)
	    showscreen(mailbox,
		       digest_menu,&header_page, page);
	
	check_range(&MENU);
	
	
	if (nucurr == NEW_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == NEW_PAGE\n"));
	    show_headers(&MENU,&header_page, page);
	} else if (nucurr == SAME_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == SAME_PAGE\n"));
	    show_current(&MENU, &header_page, page);
	} else if (nufoot) {
	    if (mini_menu) {
		MoveCursor(LINES-8, 0);  
		CleartoEOS();
		digest_menu(page);
	    }
	    else {
		MoveCursor(LINES-5, 0);
		CleartoEOS();
	    }
	    show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
	}

    } /* the BIG while loop! */

 OUT:
    erase_menu_context(&page);

}

void ViewDigest(parent_mailbox, aview)
     struct MailboxView *parent_mailbox;
     struct AliasView *aview;
{
    int oldstat = 0, tagged = 0;
    int mc,i;
    struct MailboxView *new_mailbox = NULL;
    int current = get_current(parent_mailbox);
    struct header_rec * chdr = give_header(parent_mailbox,current-1);

    if (chdr) 
	oldstat = chdr->status;	/* remember */

    mc = get_message_count(parent_mailbox);
    for (i=0; i < mc; i++) {
	struct header_rec * hdr = give_header(parent_mailbox,i);
	if (hdr && ison(hdr->status, TAGGED)) {
	    tagged++;
	}
    }

    if (tagged == 0) {

	tagged = 1;
	if (chdr)
	    setit(chdr->status, TAGGED);
    }

    mc = get_message_count(parent_mailbox);
    for (i=0; i < mc; i++) {	/* get each tagged msg */
	struct header_rec * hdr = give_header(parent_mailbox,i);
	if (hdr && ison(hdr->status, TAGGED)) {
	    FILE *F;

	    clearit(hdr->status, TAGGED);

	    if (give_message_data(parent_mailbox,i,
				  &hdr,&F,NULL,
				  mime_parse_routine)) {
		if (new_mailbox)
		    add_digest(new_mailbox,
			       & hdr->mime_rec,
			       hdr->received_time,
			       hdr->env_from,
			       F,
			       hdr->header_charset);
		else
		    new_mailbox = 
			digest_to_mailbox_view(& hdr->mime_rec,
					       hdr->received_time,
					       hdr->env_from,
					       F,
					       hdr->header_charset);
	    }

	}
    }

    if (chdr)
	chdr->status = oldstat;	/* BACK! */


    if (new_mailbox) {
	int header_page = 0;
	if (get_message_count(new_mailbox) > 0) {
	    set_current(new_mailbox,1);   /* Set current to first message */

	    update_view(new_mailbox);
	    resort_mailbox(new_mailbox,1, &header_page);
	}

	digest_loop(new_mailbox, aview, header_page);

	free_mailbox(& new_mailbox);
    }

    return;
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */

