case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	ln ../../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac

echo "Extracting src/menu_common/Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#!$make
# $Id: Makefile.SH,v 1.2 2004/02/20 19:38:10 hurtta Exp $
#  Makefile for the ELM mail program.
#
# Variables
#	Variables established by Configure
AR		=	ar
CC		=	$cc
CCFLAGS		=	$ccflags $picflag $xencf
CHMOD		=	$chmod
LINT		=	$lint
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
RM		= 	$rm -f
TOUCH		=	$touch
TAGS		=	ctags

!GROK!THIS!
cat >>Makefile <<'!NO!SUBS!'
#	Other general variables
CFLAGS		=	-I$(INCLDIR) $(CCFLAGS) $(OPTIMIZE) $(DEBUG) 
INCLDIR		=	../../hdrs
LINTFLAGS	=	-I$(INCLDIR)
SHELL		=	/bin/sh

OBJ		=	mcommon.o alias.o mailbox.o alias_limit.o \
 message_limit.o alias_pattern.o message_pattern.o alias_screen.o \
 message_screen.o alias_item.o mailbox_item.o

all:			Makefile libmcommon.a

install_s:		Makefile libmcommon.a

uninstall_s:		

clean:
	$(RM) $(OBJ) libmcommon.a

Makefile: Makefile.SH ../../config.sh
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

libmcommon.a:		$(OBJ)
			$(AR) r $@ $?
			$(RANLIB) $@

#	Dependencies of header files upon other header files they include
.PRECIOUS:		$(INCLDIR)/defs.h $(INCLDIR)/headers.h def_aliases.h

$(INCLDIR)/defs.h:	$(INCLDIR)/../config.h $(INCLDIR)/sysdefs.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

$(INCLDIR)/headers.h:	$(INCLDIR)/defs.h $(INCLDIR)/mime.h $(INCLDIR)/me.h $(INCLDIR)/elmlib.h
			$(CHMOD) u+w $@
			$(TOUCH) $@

def_mcommon.h:		$(INCLDIR)/headers.h $(INCLDIR)/me.h 
			$(CHMOD) u+w $@
			$(TOUCH) $@

#	Dependencies of C object files
mcommon.o:	     def_mcommon.h     
alias.o:	     def_mcommon.h     
mailbox.o:	     def_mcommon.h     
mailbox.o:	     def_mcommon.h     
alias_limit.o:	     def_mcommon.h $(INCLDIR)/s_aliases.h $(INCLDIR)/s_elm.h
message_limit.o:     def_mcommon.h $(INCLDIR)/s_elm.h    
alias_pattern.o:     def_mcommon.h
message_pattern.o:   def_mcommon.h $(INCLDIR)/s_elm.h    
alias_screen.o:     def_mcommon.h
message_screen.o:   def_mcommon.h $(INCLDIR)/s_elm.h    
alias_item.o:       def_mcommon.h $(INCLDIR)/s_aliases.h $(INCLDIR)/s_elm.h    
mailbox_item.o:     def_mcommon.h $(INCLDIR)/s_elm.h    
!NO!SUBS!
