static char rcsid[] = "@(#)$Id: mailbox_item.c,v 1.3 2004/03/27 18:31:48 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.3 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI>
 *****************************************************************************
 *  Include some miminal code from init.c  which have following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_mcommon.h"
#include "s_elm.h"

CONST struct string * mc_give_item_mbx(I)
     enum mcommon_item I;
{
    static struct string * storage[MCOMMON_ITEM_COUNT] = { NULL };

    if (I < 0 || I >= MCOMMON_ITEM_COUNT)
	panic("MENU COMMON PANIC",__FILE__,__LINE__,"mc_give_item_mbx",
	      "bad item",0);

    /* NOTICE: storage pointers are leaked on end of program */
  
    switch(I) {

    case m_item:
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, Elmitem, "message"));
	break;
	    
    case m_items:
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, Elmitems, "messages"));
	break;
		
    case m_Item:
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, ElmItem, "Message"));
	break;
	
    case m_Items:
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, ElmItems, "Messages"));
	break;
	
    case m_Prompt: 
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, ElmPrompt, "Command: "));
	break;

    case m_no_item:
	if (! storage[I])
	    storage[I] = format_string(CATGETS(elm_msg_cat, ElmSet, ElmNoMailInFolder,
					       "No mail in folder!"));
	break;
	
    default:
	panic("MENU COMMON PANIC",__FILE__,__LINE__,"mc_give_item_mbx",
	      "bad item",0);

    }

    if (! storage[I])
	panic("MENU COMMON PANIC",__FILE__,__LINE__,"mc_give_item_mbx",
	      "item not initialized",0);
	
    return storage[I];
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
