static char rcsid[] = "@(#)$Id: partial.c,v 1.10 2004/07/26 12:41:47 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.10 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> 
 *                      (was hurtta+elm@ozone.FMI.FI)
 ******************************************************************************
 * This routine mimics some routines from src/file.c and src/elm.c.
 * That code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "def_elm.h"
#include "s_elm.h"

DEBUG_VAR(Debug,__FILE__,"ELM");

static void partial_menu P_((struct menu_context *page));
static void partial_menu(page)
     struct menu_context *page;
{
    /** write main system menu... **/
    int LINES, COLUMNS;

    menu_get_sizes(default_context,&LINES, &COLUMNS);
    

    if (user_level == 0) {	/* a rank beginner.  Give less options  */
	print_format_center(LINES-8, 
			      CATGETS(elm_msg_cat, ElmSet, 
				      ElmLevel0MenuLine1,
				      "You can use any of the following commands by pressing the first character;"));
         print_format_center(LINES-7, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0PartLine2,
				     "d)elete or u)ndelete mail,  m)ail a message,  r)eply or f)orward mail,  return to i)ndex"));
	 print_format_center(LINES-6, 
			     CATGETS(elm_msg_cat, ElmSet, 
				     ElmLevel0PartLine3,
				     "To read a message, press <return>.  j = move down, k = move up"));
    } else {
	print_format_center(LINES-8, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1MenuLine1,
				    "|=pipe, !=shell, ?=help, <n>=set current to n, /=search pattern"));
        print_format_center(LINES-7, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1PartLine2,
				    "a)lias, C)opy, d)elete, f)orward, g)roup reply, m)ail,"));
	print_format_center(LINES-6, 
			    CATGETS(elm_msg_cat, ElmSet, 
				    ElmLevel1PartLine3,
				    "n)ext, o)ptions, P)rint text, r)eply, s)ave, t)ag, or i)index"));
    }
}

static int showmsg_partial_cmd P_((     struct MailboxView *mailbox,
				       int cmd, int *screen_mangled,
					struct menu_context *page));
static int showmsg_partial_cmd(mailbox,cmd,screen_mangled, page)
     struct MailboxView *mailbox;
     int cmd; 
     int *screen_mangled;
     struct menu_context *page;
{
    struct menu_common MENU;
    
    set_mcommon_from_mbxview(&MENU,mailbox);

    switch (cmd) {
    case '|' : {
	int current = get_current(mailbox);
	
	put_cmd_name(catgets(elm_msg_cat, ElmSet, ElmPipe, "Pipe"), 
		     TRUE, &MENU, page);
	
	if (give_message_data(mailbox,current-1,
			      NULL,NULL,NULL,
			      NO_mime_parse))
	    (void) do_pipe(mailbox, page);     /* do pipe - ignore return val */
	else {
	    DPRINT(Debug,3,(&Debug, 
			    "give_message_data [%d] fails",current-1));
	}
	menu_ClearScreen(page);
	build_bottom(&MENU,page);
    }
	break;
    }

    return cmd;
}


static void partial_loop P_((struct MailboxView *mailbox,
			     struct AliasView *aview,
			     int header_page));
static void partial_loop(mailbox, aview, header_page)
     struct MailboxView *mailbox;
     struct AliasView *aview;     
     int header_page;
{
    int leave = 0;
    int redraw = 0, nufoot = 0;

    struct menu_context  *page = new_menu_context();

    struct menu_common MENU;
    int   LINES, COLUMNS;	

    menu_get_sizes(page,&LINES, &COLUMNS);

    set_mcommon_from_mbxview(&MENU,mailbox);

    showscreen(mailbox,
	       partial_menu,&header_page, page);


    while (!leave) {
	int ch;

	if (menu_resized(page)) {
	    
	    menu_get_sizes(page,&LINES, &COLUMNS);

#undef max
#define max(a,b)	       ((a) < (b) ? (b) : (a))
		if (mini_menu)
		    headers_per_page = max (LINES - 14, 1);
		else
		    headers_per_page = max (LINES -  9, 1);	  /* 5 more headers! */
#undef max
		redraw++;
	} else 
	    redraw = menu_need_redraw(page);
	
	nufoot = 0;
	nucurr = 0;

	new_mail_check(mailbox, &header_page, page);
	redraw += menu_need_redraw(page);

	if (update_view(mailbox)) {
	    resort_mailbox(mailbox,1, &header_page);

	    redraw++;
	}

	if (redraw) {
	    redraw = 0;
	    showscreen(mailbox,
		       partial_menu,&header_page, page);
	    show_last_error();
	}
	

	  {
	      int lin,col;
	      prompt_s(mcommon_give_item(&MENU,m_Prompt));
	      GetXYLocation(&lin,&col);

	      CleartoEOLN();
	      ch = GetPrompt(page);
	
	      CleartoEOS();
	      
	      if (isascii(ch) && isprint(ch)) {
		  DPRINT(Debug,4,(&Debug, 
				  "\nCommand: %c [%d]\n\n", ch, ch));
	      } else {
		  DPRINT(Debug,4,(&Debug, 
				  "\nCommand: %d\n\n", ch));
	      }
	      
	      set_error("");	/* clear error buffer */
	      
	      MoveCursor(lin,col);
	  }

	ch = mailbox_command(mailbox,ch, &nufoot,
			     showmsg_partial_cmd, aview, &header_page,
			     page);

	redraw += menu_need_redraw(page);

	switch (ch) {
	case 0:  /* OK */
	    break;

	case '|'    :   {
	    int current = get_current(mailbox);
	    
	    Writechar('|');
	    
	    if (current < 1) {
		lib_error(CATGETS(elm_msg_cat, ElmSet, 
				  ElmNoMailToPipe,
				  "No mail to pipe!"));
		
	    } else if (give_message_data(mailbox,current-1,
					 NULL,NULL,NULL,NO_mime_parse)) {
		
		/* softkeys_off(); */
		
		do_pipe(mailbox, page);		
		redraw += menu_need_redraw(page);

		/* softkeys_on(); */
	    } else {
		DPRINT(Debug,3,(&Debug, 
				"give_message_data [%d] fails",current-1));
	    }
	}
	    break;


	case ctrl('Q') :
	case 'q':
	case 'Q':
	case 'i':
	case 'x':
	case 'X':
	    Write_to_screen(CATGETS(elm_msg_cat, ElmSet,
				    ElmReturnIndex,
				    "Return to index"));  
	    FlushBuffer();

	    leave = 1;

	    break;
	case EOF:
	    
	    return;

	default:
	    lib_error(CATGETS(elm_msg_cat, ElmSet,
			      ElmUnknownCommand2,			
			      "Unknown command."));

	}
	
	if (redraw)
	    showscreen(mailbox,
		       partial_menu,&header_page, page);
	
	check_range(&MENU);
	
	
	if (nucurr == NEW_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == NEW_PAGE\n"));
	    show_headers(&MENU,&header_page, page);
	} else if (nucurr == SAME_PAGE) {
	    DPRINT(Debug,5,(&Debug,  " nucurr == SAME_PAGE\n"));
	    show_current(&MENU,&header_page, page);
	} else if (nufoot) {
	    if (mini_menu) {
		MoveCursor(LINES-8, 0);  
		CleartoEOS();
		partial_menu(page);
	    }
	    else {
		MoveCursor(LINES-5, 0);
		CleartoEOS();
	    }
	    show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
	}

    } /* the BIG while loop! */

 OUT:
    erase_menu_context(&page);

}

void ViewPartial(parent_mailbox, aview)
     struct MailboxView *parent_mailbox;
     struct AliasView *aview;     
{
    struct MailboxView *new_mailbox = NULL;

    new_mailbox = partial_to_mailbox_view(parent_mailbox);

    if (new_mailbox) {
	int header_page = 0;
	if (get_message_count(new_mailbox) > 0) {
	    set_current(new_mailbox,1);   /* Set current to first message */

	    update_view(new_mailbox);
	    resort_mailbox(new_mailbox,1, &header_page);
	}

	partial_loop(new_mailbox, aview, header_page);

	free_mailbox(& new_mailbox);
    }

    return;
}

int have_partial(parent_mailbox)
     struct MailboxView *parent_mailbox;
{
    int mc = get_message_count(parent_mailbox);
    int i;
    
    for (i = 0; i < mc; i++) {
	struct header_rec * hdr = give_header(parent_mailbox,i);
	int z;

	if (hdr && (hdr->partial_len ||
		    (hdr->status & MIME_MESSAGE) &&
		    (z = get_type_flags(hdr->mime_rec.TYPE)) &&
		    ( z & MIME_PARTIAL))) {
	    DPRINT(Debug,4,(&Debug, 
			    "have_partial=1   (message %d)\n",
			    i+1));
	    return 1;
	}

    }

    DPRINT(Debug,9,(&Debug, 
		    "have_partial=0   (message %d)\n"));

    return 0;
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
