/* $Id: def_screen.h,v 1.8 2004/07/13 14:39:29 hurtta Exp $ */

#include "headers.h"
#include "me.h"


extern int InGetPrompt;         /* set if in GetPrompt() in read() */
/* HACK */

#define pg_BOLD       0x01
#define pg_UNDERLINE  0x02
#define pg_HALFBRIGHT 0x04
#define pg_INVERSE    0x08


/* curses.c */


extern int cur_tabspacing;           /* Default? */

extern int cur_InitScreen P_((void));

extern int terminal_fd;
extern int outchar P_((int c));

extern charset_t target_display_charset;
extern struct charset_state * last_state;
extern screen_info_p  last_display_state;

extern char terminal_type[];

/* DO NOT return lines-1 (as ScreenSize() did) */

extern void cur_ScreenSize P_((int *lines, int *columns));
extern void cur_GetXYLocation P_((int *line, int *col));
extern int  cur_ClearScreen P_((struct menu_context *mc));
extern void cur_CursorUp    P_((int n));
extern void cur_CursorDown  P_((int n));
extern void cur_CursorLeft  P_((int n));
extern int cur_MoveCursor P_((int row, int col));

extern void cur_changemode P_((int *mode, int set, int reset));

/* This assumes one byte charset */
extern void cur_Writechar P_((int ch));

extern void cur_PutLineS P_((struct string *S));

extern void cur_Write_to_screen P_((const char *format, 
				    const char *msg, ...));

extern void cur_PutLine0 P_((int x, int y, const char *line));
extern void cur_PutLineX P_((int x, int y, const char *format, 
			     const char *line, ...));
extern int cur_CleartoEOLN P_((void));
extern int cur_CleartoEOS P_((void));

extern int cur_RawState P_((void));

/* NOTE: Is called from signal handler! */
extern void cur_Raw P_((int state));

void limit_position P_((int *row, int *col));

extern void transmit_functions P_((int newstate));


#if POLL_METHOD	  
extern void clear_input_buffer P_((void));  
#endif

extern int cur_ReadCh P_((int flags, int break_flag,
			  struct menu_context *mc));
extern struct charset_state * cur_ReadCh2 P_((int flags,
					      int break_flag,
					      struct menu_context *mc));

extern int  cursor_control;
extern int _intransmit;	        /* are we transmitting keys? */
extern char *_key_up, *_key_down, *_key_left, *_key_right,
  *_key_pageup, *_key_pagedown, *_key_home, 
  *_key_help, *_key_find;
extern char *_transmit_on,  *_transmit_off; 

#ifdef TERMIOS
# include <termios.h>

struct tf_state {
    struct termios old_raw;
    int old_raw_ok;
};

extern int toggle_lflag P_((struct tf_state *T,int enab,int disab) );
extern void reset_lfag P_((struct tf_state *T));
#endif

/* cur_process.c */

extern void print_status P_((struct run_state *rs,int sig,int exit_code));
extern void start_run_tty_init P_((void));
extern void print_status_cooked P_((struct run_state *rs,int sig,
				    int exit_code));

/* -------------------------------------------------------------------- */

#define MENU_CONTEXT_magic      0xF800

extern struct menu_context {
    unsigned short         magic; /* MENU_CONTEXT_magic */

    int lines, columns;
    int changed;
    int redraw;
    
    struct menu_context * next_menu;
    struct menu_context * prev_menu;
} ROOT_MENU, COOKED_MENU;

extern void check_changes P_((void));

/* init.c */

extern void get_term_chars P_((int fd));

extern char backspace,		/* the current backspace char */
       kill_line,		/* the current kill-line char */
       word_erase,		/* the current word-erase char */
       interrupt_char,		/* the current interrupt char */
       reprint_char,		/* the current reprint-line char */
      eof_char;			/* the current end-of-file char */

extern char VQUIT_char,         /* the current quit char */
       VSUSP_char;              /* the current suspend char */

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
