static char rcsid[] = "@(#)$Id: termcharset.c,v 1.4 2004/03/27 18:31:48 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.4 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI> (was hurtta+elm@ozone.FMI.FI)
 *****************************************************************************/

#include "def_screen.h"

DEBUG_VAR(Debug,__FILE__,"elmpage");

charset_t target_display_charset = NULL;
struct charset_state * last_state = NULL;
screen_info_p  last_display_state = NULL;


charset_t * give_display_charsets(storage,max)
     charset_t *storage;
     int max;
{
    int n = 0,i;
    max--;

    storage[n++] = display_charset;

    if (system_charset != display_charset &&
	n < max)
	storage[n++] = system_charset;

    if (allow_charset_switching)
	terminal_can_switch(terminal_type,storage,&n,max);
    storage[n] = NULL;

    SIGDPRINT(Debug,4,(&Debug, 
		    "Possible sets:"));
    for (i = 0; i < n; i++) {
	SIGDPRINT(Debug,4,(&Debug, 
			" %s%c",
			storage[i]->MIME_name ? storage[i]->MIME_name : 
			"<no MIME name>",
			i < n-1 ? ',' : '\n'));
    }

    return storage;
}


int set_display_charset(set,silent)
     charset_t set; 
     int silent;
{   
    if (!terminal_can_switch_to(terminal_type,set,silent))
	return 0;

    target_display_charset = set;
    switch_display_charset(1);
    return 1;
}

void switch_display_charset(to_display)
     int to_display;
{
    char buffer[256];

    charset_t t;
    char * str;
    
    if (!target_display_charset)
	target_display_charset = display_charset;
    

    if (!last_display_state)
	last_display_state = create_terminal_info();


    t = to_display ? target_display_charset : system_charset;
    
    if (!t) {
	SIGDPRINT(Debug,4,(&Debug, 
			   "switch_display_charset: target charset is NULL\n"));
	return;
    }

    str = terminal_switch_to(terminal_type,t,&last_display_state,
			     buffer, sizeof buffer);

    if (str) {
	int i;

	SIGDPRINT(Debug,4,(&Debug, 
			"Setting display charset to %s (",
			t->MIME_name ? t->MIME_name : "<no MIME name>"));
	for (i = 0; str[i]; i++) {
	    SIGDPRINT(Debug,4,(&Debug, 
			    "%s%02X",
			    i ? " " : "", str[i]));
	}
	SIGDPRINT(Debug,4,(&Debug,
		  ") [terminal %s]\n",terminal_type));
	
	for (i = 0; str[i]; i++) {
	    outchar(str[i]);
	}

	display_charset = t;
      
    } else {
	SIGDPRINT(Debug,4,(&Debug,
			    "No way to set terminal %s to charset %s\n",
			    terminal_type,
			    t->MIME_name ? t->MIME_name : "<no MIME name>"));
		  
    }
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
